
import java.awt.*;
import javax.swing.*;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.imageio.*;
import java.io.*;
import java.awt.image.*;
import java.net.*;
import java.awt.event.*;
/**
 *Clase que implementa una alarma indicando
 *nivel cero en el estanque 1
 *
 * @author Daniel Zuleta
 * @author Mauricio Diaz
 */

public class Alarma extends Equipment{
    
    private BufferedImage trumpet;
    private boolean active,tick;
    private int cuenta;
    private SoundApplet sound;
     /**
     *Constructor de la alarma
     */

    public Alarma() {
	
	cuenta = 19;
	active = false;
	tick = false;
	sound = new SoundApplet("ding2.wav");
	
	   
	try {
	    
	  	
	//    File sourceimage = new File("controller.png");  // As applicatios, this is OK.
			URL url = getClass().getResource("Trumpet.png");  //it works for applications and applets.
			trumpet = ImageIO.read(url);
		} catch (IOException e) {
	    }
	
    }
     /**
     *Metodo implementado segun la clase abstracta Equipment
	  *para llamar a repintado de las componentes
     */

    public void paint(Graphics2D g2d){
	if(active) g2d.drawImage(trumpet, null,600, 300);
	else g2d.drawImage(null, null,400, 200);
    }
	 
    public void timeTick(float dt){
	
	if(tick){
	
	if(cuenta == 20){ 
	    if(active){
		sound.stopSound();
		active = false;
	    }
	    else {
		sound.playSound();
		active = true;
	    }
	    cuenta = 0;
	}
	cuenta++;
	}
    }
	  /**
     *Metodo que inicia la alarma
     */

    public void start(){
	tick = true;
    }
	 /**
     *Metodo que finaliza la alarma
     */
    public void stop(){
	tick = false;
	active = false;
	cuenta = 19;
	
    }
	 /**
     *Metodo con el cual se entrega el GUI de la clase
	  *return La interfaz que implementa la clase
     */

    public Box getGUI(){
	Box gui = new Box(BoxLayout.X_AXIS);
	return gui;
    }
}
